clear all
 ...
global scalv_ ex_ ex_det_ recur_ recurs_ ys_ y_ exe_ exe_det_ lgy_ lgx_ lgx_det_ lgr_ dsmpl_ endval_
 ...
global endo_nbr exo_nbr exo_det_nbr iy_  ykmin_  ykmax_  xkmin_  xkmax_ zkmin_ zkmax_ iter_
 ...
global dynatol_ slowc_ maxit_ valf_ ys0_ recurs0_ ex0_ timing_ ct_ gstep_ Sigma_e_ fname_ lgx_orig_ord_ iter_ options_ dr_ oo_ trend_coeff_ eigenvalues_
global M_
M_.ex_det_length = 0;
M_.dname = 'DSGE';
endo_nbr=0;exo_nbr=0;exo_det_nbr=0;
dsmpl_=0;
dynatol_=0.00001;
maxit_=10;
slowc_=1;
timing_=0;
ct_=0;
gstep_=1e-2;
endval_=0;rplottype_=0;
valf_=0;
y_=[];
ex_=[];
ex_det_=[];
fname_ = 'DSGE';
logname_ = 'DSGE.log';
diary off;
warning off;
delete DSGE.log;
warning on;
warning backtrace;
diary DSGE.log;
options_ = [];
%DSGE model pro odhad potencialniho produktu
clc;
close all;

%definice promennych
%endogenni
lgy_ = 'a';
lgy_ = str2mat(lgy_,'d');
lgy_ = str2mat(lgy_,'n');
lgy_ = str2mat(lgy_,'phi');
lgy_ = str2mat(lgy_,'pi');
lgy_ = str2mat(lgy_,'r');
lgy_ = str2mat(lgy_,'u');
lgy_ = str2mat(lgy_,'u_f');
lgy_ = str2mat(lgy_,'y');
lgy_ = str2mat(lgy_,'y_f');
lgy_ = str2mat(lgy_,'z');
endo_nbr = 11;


%exogenni
lgx_ = 'epsilon_a';
lgx_ = str2mat(lgx_,'epsilon_d');
lgx_ = str2mat(lgx_,'epsilon_r');
lgx_ = str2mat(lgx_,'epsilon_z');
lgx_orig_ord_ = [4 2 1 3];
exo_nbr = 4;


%parametry

global beta eta h omega psi_pi psi_y rho_a rho_d rho_r rho_z 
global tau 


%kalibrace modelu - nastaveni hodnot paramteru
tau = 2.3128;
beta = 0.99;
h = 0.9661;
eta = 1.5442;
omega = 0.7944;
psi_pi = 1.3157;
psi_y = 0.2706;
rho_r = 0.7290;
rho_d = 0.8308;
rho_z = 0.5724;
rho_a = 0.9336;

%modelove rovnice - rovnice jiz log-linearizovane - upresnime volbou linear
options_.linear=1;
iy_ = [ 1 2 0 0 0 3 0 0 4 5 6];
temp = [ 7 8 9 10 11 12 13 14 15 16 17];
iy_ = [ iy_ ; temp ];
temp = [ 0 18 0 0 19 0 20 0 21 22 23];
iy_ = [ iy_ ; temp ];
ykmin_ = 1;
ykmax_ = 1;
xkmin_ = 0;
xkmax_ = 0;
zkmin_ = 0;
zkmax_ = 0;
ys_ = zeros(11,1);
exe_ = zeros(4,1);


%nastaveni pocatecnich podminek pro vypocet steady statu - model je gapovy, steady state je tedy pro vsechny promenne 0
% INITVAL 
valf_ = 0;
endval_=0;
ys_(9)=0;
ys_(6)=0;
ys_(5)=0;
ys_(2)=0;
ys_(3)=0;
ys_(11)=0;
ys_(10)=0;
ys_(1)=0;
y_=[ys_*ones(1,ykmin_)];
if exo_nbr > 0;
  ex_=[ones(xkmin_,1)*exe_'];
end;
if exo_det_nbr > 0;
  ex_det_=[ones(ykmin_+1,1)*exe_det_'];
end;

%u, u_f, phi si sam dopocita

%specifikace soku
sigma_r = 0.3355;%sigma_r - smerodatna odchylka pro monetarni sok
sigma_d = 1.0901;%sigma_d - smerodatna odchylka pro poptavkovy sok
sigma_z = 0.4230;%sigma_z - smerodatna odchylka pro nabidkovy sok
sigma_a = 1.4366;%sigma_a - smerodatna odchylka pro technologicky sok

% (M)SHOCKS 
make_ex_;
shocks_file(0);
Sigma_e_ = zeros(4,4);
Sigma_e_(3,3) = (sigma_r)^2;
Sigma_e_(2,2) = (sigma_d)^2;
Sigma_e_(4,4) = (sigma_z)^2;
Sigma_e_(1,1) = (sigma_a)^2;


%vypocet steady statu
% vystup - lgy_ - abecedne serazene promenne, ys_ hodnoty steady statu
steady(0);


%jedina stabilni rovnovah v okoli steady statu - pocet vlastnich cisel modelu musi byt stejny jako pocet promenych v ocekavanich
%vystup - eigenvalues_ - hodnoty vlastnich cisel
check;


%stochasticka simulace - muzu za to napsat promenny pro ktery to chci
%volby -    irf - delka pro impulsni odezvy
%           simul - simulace modelu - data ulozena do y_ + kazda promena je ve svem nazvu
%           periods - delka simulace
options_.irf=20;
var_list_ = 'y';
var_list_ = str2mat(var_list_,'pi');
var_list_ = str2mat(var_list_,'r');
var_list_ = str2mat(var_list_,'y_f');
info=stoch_simul(var_list_);


save IRF_A pi_epsilon_a r_epsilon_a y_epsilon_a y_f_epsilon_a;
save IRF_D pi_epsilon_d r_epsilon_d y_epsilon_d y_f_epsilon_d;
save IRF_R pi_epsilon_r r_epsilon_r y_epsilon_r y_f_epsilon_r;
save IRF_Z pi_epsilon_z r_epsilon_z y_epsilon_z y_f_epsilon_z;save('DSGE_results','oo_','dr_');
diary off
