clear all
close all
clc

%delka IRF
load IRF_A.mat

n = length(pi_epsilon_a);
t = 1:n;
t = t';
t2 = 0:n;
t2 = t2';
z = zeros(n+1,1);

%technologicky sok
figure
subplot(2,2,1)
plot(t,pi_epsilon_a,'b',t2,z,'k')
title('\pi')
xlim([0 n])
ylim([-0.4 0.03])

subplot(2,2,2)
plot(t,r_epsilon_a,'b',t2,z,'k')
title('r')
xlim([0 n])
ylim([-0.25 0.02])

subplot(2,2,3)
plot(t,y_epsilon_a,'b',t2,z,'k')
title('y')
xlim([0 n])
ylim([-0.05 0.85])

subplot(2,2,4)
plot(t,y_f_epsilon_a,'b',t2,z,'k')
title('y^f')
xlim([0 n])
ylim([-0.05 0.85])

%poptavkovy sok
load IRF_D.mat
figure
subplot(2,2,1)
plot(t,pi_epsilon_d,'b',t2,z,'k')
title('\pi')
xlim([0 n])
ylim([-0.02 0.25])

subplot(2,2,2)
plot(t,r_epsilon_d,'b',t2,z,'k')
title('r')
xlim([0 n])
ylim([-0.02 0.2])

subplot(2,2,3)
plot(t,y_epsilon_d,'b',t2,z,'k')
title('y')
xlim([0 n])
ylim([-0.05 0.7])

subplot(2,2,4)
plot(t,y_f_epsilon_d,'b',t2,z,'k')
title('y^f')
xlim([0 n])
ylim([-0.05 0.7])

%monetarni sok
load IRF_R.mat
figure
subplot(2,2,1)
plot(t,pi_epsilon_r,'b',t2,z,'k')
title('\pi')
xlim([0 n])
ylim([-0.15 0.01])

subplot(2,2,2)
plot(t,r_epsilon_r,'b',t2,z,'k')
title('r')
xlim([0 n])
ylim([-0.02 0.3])

subplot(2,2,3)
plot(t,y_epsilon_r,'b',t2,z,'k')
title('y')
xlim([0 n])
ylim([-0.07 0.005])

subplot(2,2,4)
plot(t,y_f_epsilon_r,'b',t2,z,'k')
title('y^f')
xlim([0 n])
ylim([-0.01 0.01])

%nakladovy sok
load IRF_Z.mat
figure
subplot(2,2,1)
plot(t,pi_epsilon_z,'b',t2,z,'k')
title('\pi')
xlim([0 n])
ylim([-0.01 0.11])

subplot(2,2,2)
plot(t,r_epsilon_z,'b',t2,z,'k')
title('r')
xlim([0 n])
ylim([-0.005 0.045])

subplot(2,2,3)
plot(t,y_epsilon_z,'b',t2,z,'k')
title('y')
xlim([0 n])
ylim([-0.04 0.003])

subplot(2,2,4)
plot(t,y_f_epsilon_z,'b',t2,z,'k')
title('y^f')
xlim([0 n])
ylim([-0.01 0.01])
