%% Data - Czech National Bank
% time : 1994.25 = 1Q1994	

%structure variables my_data (data), my_pop (labels)
%{
             time: 'Time'
             LF_2: [1x93 char]
                L: 'Zamestnanost celkem  ks'
         U_Number: 'pocet nezamestnanych'
    U_Number_VSPS: [1x60 char]
               Yn: 'hruby domaci produkt, nominalni '
               Yr: 'hruby domaci produkt, realny'
              GDP: 'Real GDP'
               RR: 'Real 3M Interbank Rate'
               RS: '3M Interbank Rate'
              RR4: 'Real 1Y Interbank Rate'
              RS4: '1Y Interbank Rate'
              PIE: 'CPI q-o-q Inflation [% pa]'
         PIE_CORE: 'Core q-o-q Inflation [% pa]'
          PIE_NET: 'Net q-o-q Inflation [% pa]'
             PIE4: 'CPI y-o-y Inflation [% pa]'
        PIE_CORE4: 'Core y-o-y Inflation [% pa]'
         PIE_NET4: 'Net y-o-y Inflation [% pa]'
%}

clear all
close all
clc

load data_Pavel.mat
					
%% Labor market
    figure
     subplot(2,2,1)
     plot(my_data.time,my_data.LF_2);
     title(my_pop.LF_2);
     
     subplot(2,2,2)
     plot(my_data.time,my_data.L);
     title(my_pop.L);

     subplot(2,2,3)
     plot(my_data.time,my_data.U_Number);
     title(my_pop.U_Number);
     
     subplot(2,2,4)
     plot(my_data.time,my_data.U_Number_VSPS);
     title(my_pop.U_Number_VSPS);
     

%% GDP
    figure
     subplot(3,1,1)
     plot(my_data.time,my_data.Yn);
     title(my_pop.Yn);

     subplot(3,1,2)
     plot(my_data.time,my_data.Yr);
     title(my_pop.Yr);

     subplot(3,1,3)
     plot(my_data.time,my_data.GDP);
     title(my_pop.GDP);


%% Interest rates
    figure
     subplot(2,2,1)
     plot(my_data.time,my_data.RR);
     title(my_pop.RR);

     subplot(2,2,2)
     plot(my_data.time,my_data.RS);
     title(my_pop.RS);

     subplot(2,2,3)
     plot(my_data.time,my_data.RR4);
     title(my_pop.RR4);

     subplot(2,2,4)
     plot(my_data.time,my_data.RS4);
     title(my_pop.RS4);


%% Inflation
    figure
     subplot(3,2,1)
     plot(my_data.time,my_data.PIE);
     title(my_pop.PIE);

     subplot(3,2,2)
     plot(my_data.time,my_data.PIE4);
     title(my_pop.PIE4);

     subplot(3,2,3)
     plot(my_data.time,my_data.PIE_CORE);
     title(my_pop.PIE_CORE);

     subplot(3,2,4)
     plot(my_data.time,my_data.PIE_CORE4);
     title(my_pop.PIE_CORE4);

     subplot(3,2,5)
     plot(my_data.time,my_data.PIE_NET);
     title(my_pop.PIE_NET);

     subplot(3,2,6)
     plot(my_data.time,my_data.PIE_NET4);
     title(my_pop.PIE_NET4);

